%% train lasso regression model

clc;

rng default;

X = randn(100,5);           % 100 samples of 5 predictors

r = [0; 2; 0; -3; 0;];      % only two non-zero coefficients

Y = X*r + randn(100,1).*0.1;  % construct target using only two coefficients



[B, I] = lasso(X,Y);

for i=1:46

    b = sprintf(' %.4f ', B(:,i));

    fprintf('Lambda=%.4f, Betas = [%s], MSE=%.4f\n',I.Lambda(i), b, I.MSE(i));

end



%% train lasso with specific lambdas

[B, I] = lasso(X,Y,'Lambda', [0.5]);

for i = 1:1

    b = sprintf(' %.10f ', exp(B(:,i)));

    fprintf('Lambda=%.4f, Betas = [%s], MSE=%.4f\n',I.Lambda(i), b, I.MSE(i));

end

%% Ridge regression

% train ridge regression with given lambda

lambda = 1;  

model = fitrlinear(X,Y,'Regularization', 'ridge', 'Lambda', lambda);

predicted_Y = predict(model, X);      % predict Y, using the X data

err = mse(predicted_Y, Y);          % compute error

b = sprintf(' %.4f ', model.Beta);

fprintf('Lambda=%.4f, Betas = [%s], MSE=%.4f\n',lambda, b, err);